-- the movie file to use
moviefile = "smo-30.smv"
-- output file. contains ingame frame, scroll, position and hitbox information
dumpfile = moviefile..".dump"
io.output(dumpfile)
-- index file. contains room transition information
indexfile = io.open(moviefile..".index", "w")
-- backwards compatibility
if movie.open then
	movie.open(moviefile)
end
prev = {}
prev.roomid1 = memory.readword(0x7ED552)
prev.roomid2 = memory.readword(0x7ED554)
prev.roomid3 = memory.readword(0x7ED556)
while true do
	if movie.mode() then
		snes9x.speedmode("turbo")
		igframe = 3600*memory.readbyte(0x7E09DE)+60*memory.readbyte(0x7E09DC)+memory.readbyte(0x7E09DA)
		roomid1 = memory.readword(0x7ED552)
		roomid2 = memory.readword(0x7ED554)
		roomid3 = memory.readword(0x7ED556)
		scrollx, scrolly = memory.readword(0x7E0911), memory.readword(0x7E0915)
		posx, posy = memory.readword(0x7E0AF6), memory.readword(0x7E0AFA)
		hitx, hity = memory.readword(0x7E0AFE), memory.readword(0x7E0B00)
		io.write(igframe, " ", roomid1, " ", roomid2, " ", roomid3, " ", scrollx, " ",
			scrolly, " ", posx, " ", posy, " ", hitx, " ", hity, "\n")
		-- keep track of door transitions. this is used in room ghost mode
		if roomid1 ~= prev.roomid1 or roomid2 ~= prev.roomid2 or roomid3 ~= prev.roomid3 then
			indexfile:write(roomid1, " ", roomid2, " ", roomid3, " ", prev.roomid1, " ", prev.roomid2, " ", prev.roomid3, " ", movie.framecount(), " ", igframe, "\n")
		end
		prev.roomid1 = roomid1
		prev.roomid2 = roomid2
		prev.roomid3 = roomid3
	else
		gui.text(10,10,"Plese load the movie file now")
	end
	snes9x.frameadvance()
end
